; Software sprite and melt platform
	
	include \asm\inc\win.inc
	include \asm\inc\gen.inc
	include \asm\inc\io.inc
	
	mov si,offset ftab
	mov di,offset ftab
	callr word ptr [bx+si]
	retf

INIT ; 0
	mov word ptr [tile],ax
	mov word ptr [backup],cx
	ret

DISPLAY ; 2
	mov word ptr [xco],ax ; Do Coords
	mov word ptr [yco],cx
	mov ax,dx
	mov cx,24 ; Do Frame
	mul cx
	add ax,312
	mov word ptr [tlx],ax
	add ax,24
	mov word ptr [brx],ax
	mov word ptr [tly],12
	mov word ptr [bry],36
	gCopyBit offset position,[tile],offset rect,1
	ret

ERASE ; 4
	mov word ptr [xco],ax ; Do Coords
	mov word ptr [yco],cx
	; Do Position in backup
	mov word ptr [tlx],ax
	add ax,24
	mov word ptr [brx],ax
	mov word ptr [tly],cx
	add cx,dx
	mov word ptr [bry],cx
	gCopyBit offset position,[backup],offset rect,4
	ret

MELT ; 6
	mov word ptr [xco],ax
	mov word ptr [yco],cx
	mov word ptr [tlx],dx
	add dx,12
	mov word ptr [brx],dx
	mov ax,0
	mov [tly],ax
	mov ax,12
	mov [bry],ax
	gCopyBit offset position,[tile],offset rect,4
	ret

CONTRAST ; 8
	HwReadLcdContrast
	mov [temp],al
	mov [count],25
loopc
	HwLcdContrastDelta 1
	mov bx,2400
delay
	dec bx
	cmp bx,0
	jne delay
	dec word ptr [count]
	cmp word ptr [count],0
	jne loopc
loopd
	HwLcdContrastDelta -1
	dec cx
	mov bx,2400
delaya
	dec bx
	cmp bx,0
	jne delaya
	HwReadLcdContrast
	cmp [temp],al
	jne loopd
	ret

GETCLICK ; 10
	GenGetSoundFlags
	ret

SETCLICK ; 12
	mov bx,ax
	GenSetSoundFlags bx
	ret

Ftab
	DW offset init
	DW offset display
	DW offset erase
	DW offset melt
	DW offset contrast
	DW offset getclick
	DW offset setclick

rect
tlx DW 0
tly DW 0
brx DW 24
bry DW 24

Backup DW 0
Tile DW 0
position
xco DW 0
yco DW 0
temp DB 0
count DW 0
